#include "common.h"

// checks if arbitrary numbers in kind are allowed

int main(){
    
    resources_init();
    
    rv = resources_create(0, 1);
    assertVerbose(rv==0, "kind: 0");
    
    for(int i = 0; i < 31; ++i){
        rv = resources_create(1<<i, 1);
        assertVerbose(rv==0, "kind: 1<<%d", i);
    }
    
    rv = resources_take(1, (struct resources_request[]){{0, 1}});
    assertVerbose(rv==0, "take kind: 0");
    rv = resources_return(0, 1);
    assertVerbose(rv==0, "return kind: 0");
    
    for(int i = 0; i < 31; ++i){
        rv = resources_take(1, (struct resources_request[]){{1<<i, 1}});
        assertVerbose(rv==0, "take kind: 1<<%d", i);
        rv = resources_return(1<<i, 1);
        assertVerbose(rv==0, "return kind: 1<<%d", i);
    }
    
    struct resources_request rr[32]={{0,1}};
    for(int i = 0; i < 31; ++i)
        rr[i+1]=(struct resources_request){1<<i, 1};
    
    rv = resources_take(32, rr);
    assertVerbose(rv==0, "take all kinds");
    
    rv = resources_return(0, 1);
    assertVerbose(rv==0, "return2 kind: 0");
    for(int i = 0; i < 31; ++i){
        rv = resources_return(1<<i, 1);
        assertVerbose(rv==0, "return2 kind: 1<<%d", i);
    }
    
    puts("ok");
    return 0;
}
