#include "common.h"

// checks if concurrent threads may freely take and return disjoint resources

enum Kind { Z, A, B, C, D, E, F };

void* t_cd(void *_){
    LOOP(
        rv = resources_take(2, (struct resources_request[]){{C,2},{D,1}});
        assert(!rv);
        rv = resources_return(D, 1);
        assert(!rv);
        rv = resources_return(C, 2);
        assert(!rv);
    )
    return _;
}

void* t_ef(void *_){
    LOOP(
        rv = resources_take(2, (struct resources_request[]){{F,2},{E,1}});
        assert(!rv);
        rv = resources_return(F, 2);
        assert(!rv);
        rv = resources_return(E, 1);
        assert(!rv);
    )
    return _;
}

int main(){
    resources_init();
    
    resources_create(A, 2);
    resources_create(B, 2);
    resources_create(C, 2);
    resources_create(D, 2);
    resources_create(E, 2);
    resources_create(F, 2);
    
    endtime = time_nanos() + 50e6;
    
    THREADS_SPAWN(t_cd, t_ef);
    
    LOOP(
        rv = resources_take(2, (struct resources_request[]){{A,2},{B,1}});
        assert(!rv);
        rv = resources_return(A, 2);
        assert(!rv);
        rv = resources_return(B, 1);
        assert(!rv);
    )
    
    THREADS_JOIN;
    puts("ok");
    return 0;
}
