#include "common.h"

// checks if concurrent threads cannot hold at the same time the same resource

enum Kind { Z, A };

atomic_int inside;

void* t(void *_){
    LOOP(
        rv = resources_take(1, (struct resources_request[]){{A,1}});
        assertVerbose(!rv, "%i", rv);
        
        assert(inside==0);
        inside++;
        nanosleep(&(struct timespec){0,5e3}, NULL);
        assert(inside==1);
        nanosleep(&(struct timespec){0,5e3}, NULL);
        inside--;
        assert(inside==0);
        
        rv = resources_return(A, 1);
        assertVerbose(!rv, "%i", rv);
    )
    return _;
}

int main(){
    resources_init();
    
    resources_create(A, 1);
    
    endtime = time_nanos() + 50e6;
    
    THREADS_SPAWN(t, t, t, t, t, t, t);
    
    t(NULL);
    
    THREADS_JOIN;
    puts("ok");
    return 0;
}
