#include "common.h"

// several threads take resources in order, and then release in a different
// order; repeated for different order of returns

enum Kind { Z, A };

void takeReturn(int states[4]){
    wait_state(states[0]);
    
    rv = resources_take(1, (struct resources_request[]){{A,4}});
    assertVerbose(!rv, "state %i", states[0]);
    
    adv_state(states[1]);
    
    wait_state(states[2]);
    
    rv = resources_return(A, 4);
    assertVerbose(!rv, "state %i", states[2]);
    
    adv_state(states[3]);
}


void* t1(void *_){
    takeReturn((int[4]){1, 2, 4, 5});
    takeReturn((int[4]){7, 8,10,11});
    takeReturn((int[4]){13,14,15,16});
    return _;
}

void* t2(void *_){
    takeReturn((int[4]){2, 3, 5, 6});
    takeReturn((int[4]){8, 9, 9, 10});
    takeReturn((int[4]){14,15,17,18});
    return _;
}

int main(){
    resources_init();
    
    resources_create(A, 12);
    
    THREADS_SPAWN(t1, t2);
    
    takeReturn((int[4]){0, 1, 3, 4});
    takeReturn((int[4]){6, 7,11,12});
    takeReturn((int[4]){12,13,16,17});
    
    THREADS_JOIN;
    puts("ok");
    return 0;
}
