#include "common.h"

// check if taking and returning the same resource can be interleaved freely

enum Kind { Z, A };

void takeReturn(int states[4]){
    wait_state(states[0]);
    
    rv = resources_take(1, (struct resources_request[]){{A,4}});
    assertVerbose(!rv, "state %i", states[0]);
    
    adv_state(states[1]);
    
    wait_state(states[2]);
    
    rv = resources_return(A, 4);
    assertVerbose(!rv, "state %i", states[2]);
    
    adv_state(states[3]);
}


void* t1(void *_){
    takeReturn((int[4]){ 1, 2, 4, 5});
    return _;
}

void* t2(void *_){
    takeReturn((int[4]){ 3, 4, 5, 6});
    return _;
}

int main(){
    resources_init();
    
    resources_create(A, 12);
    
    THREADS_SPAWN(t1, t2);
    
    takeReturn((int[4]){ 0, 1, 2, 3});
    
    THREADS_JOIN;
    puts("ok");
    return 0;
}
