#include "common.h"

// a number of threads taking same resources in a different order

enum Kind { Z, A, B, C, D };

struct resources_request permutations[24][4]={
  {{D,1}, {C,1}, {A,1}, {B,1}},
  {{D,1}, {C,1}, {B,1}, {A,1}},
  {{D,1}, {A,1}, {C,1}, {B,1}},
  {{D,1}, {B,1}, {C,1}, {A,1}},
  {{D,1}, {A,1}, {B,1}, {C,1}},
  {{D,1}, {B,1}, {A,1}, {C,1}},
  {{C,1}, {D,1}, {A,1}, {B,1}},
  {{C,1}, {D,1}, {B,1}, {A,1}},
  {{A,1}, {D,1}, {C,1}, {B,1}},
  {{B,1}, {D,1}, {C,1}, {A,1}},
  {{A,1}, {D,1}, {B,1}, {C,1}},
  {{B,1}, {D,1}, {A,1}, {C,1}},
  {{C,1}, {A,1}, {D,1}, {B,1}},
  {{C,1}, {B,1}, {D,1}, {A,1}},
  {{A,1}, {C,1}, {D,1}, {B,1}},
  {{B,1}, {C,1}, {D,1}, {A,1}},
  {{A,1}, {B,1}, {D,1}, {C,1}},
  {{B,1}, {A,1}, {D,1}, {C,1}},
  {{C,1}, {A,1}, {B,1}, {D,1}},
  {{C,1}, {B,1}, {A,1}, {D,1}},
  {{A,1}, {C,1}, {B,1}, {D,1}},
  {{B,1}, {C,1}, {A,1}, {D,1}},
  {{A,1}, {B,1}, {C,1}, {D,1}},
  {{B,1}, {A,1}, {C,1}, {D,1}}
};


void* func(void *arg){
    int i = (intptr_t) arg;
    LOOP(
        rv = resources_take(4, permutations[i]);
        assertVerbose(!rv, "rv=%i", rv);
        
        for(int i = 0; i < 64; ++i) asm("nop");
        
        for(int k = 0; k < 4; ++k){
            rv = resources_return(permutations[i][k].kind,1);
            assertVerbose(!rv, "rv=%i", rv);
        }
    )
    return NULL;
}
int main(){
    resources_init();
    
    resources_create(A, 1);
    resources_create(B, 1);
    resources_create(C, 1);
    resources_create(D, 1);
    
    endtime = time_nanos() + 50e6;
    
    pthread_t t[24];
    for(intptr_t i = 1; i < 24; ++i)
        pthread_create(t+i, NULL, func, (void*)i);
    
    func(0);
    
    for(intptr_t i = 1; i < 24; ++i)
        pthread_join(t[i], NULL);
    
    puts("ok");
    return 0;
}
