#include "common.h"

// a number of threads taking same resources in a different order; each
// resource is returned in two chunks
// there are 3 items of each resource, each request is for two of them

enum Kind { Z, A, B, C, D };

struct resources_request permutations[24][4]={
  {{D,2}, {C,2}, {A,2}, {B,2}},
  {{D,2}, {C,2}, {B,2}, {A,2}},
  {{D,2}, {A,2}, {C,2}, {B,2}},
  {{D,2}, {B,2}, {C,2}, {A,2}},
  {{D,2}, {A,2}, {B,2}, {C,2}},
  {{D,2}, {B,2}, {A,2}, {C,2}},
  {{C,2}, {D,2}, {A,2}, {B,2}},
  {{C,2}, {D,2}, {B,2}, {A,2}},
  {{A,2}, {D,2}, {C,2}, {B,2}},
  {{B,2}, {D,2}, {C,2}, {A,2}},
  {{A,2}, {D,2}, {B,2}, {C,2}},
  {{B,2}, {D,2}, {A,2}, {C,2}},
  {{C,2}, {A,2}, {D,2}, {B,2}},
  {{C,2}, {B,2}, {D,2}, {A,2}},
  {{A,2}, {C,2}, {D,2}, {B,2}},
  {{B,2}, {C,2}, {D,2}, {A,2}},
  {{A,2}, {B,2}, {D,2}, {C,2}},
  {{B,2}, {A,2}, {D,2}, {C,2}},
  {{C,2}, {A,2}, {B,2}, {D,2}},
  {{C,2}, {B,2}, {A,2}, {D,2}},
  {{A,2}, {C,2}, {B,2}, {D,2}},
  {{B,2}, {C,2}, {A,2}, {D,2}},
  {{A,2}, {B,2}, {C,2}, {D,2}},
  {{B,2}, {A,2}, {C,2}, {D,2}}
};


void* func(void *arg){
    int i = (intptr_t) arg;
    LOOP(
        rv = resources_take(4, permutations[i]);
        assert(!rv);
        
        for(int i = 0; i < 32; ++i) asm("nop");
        
        for(int k = 0; k < 4; ++k){
            rv = resources_return(permutations[i][k].kind,1);
            assert(!rv);
        }
        
        for(int i = 0; i < 32; ++i) asm("nop");
        
        for(int k = 0; k < 4; ++k){
            rv = resources_return(permutations[i][k].kind,1);
            assert(!rv);
        }
    )
    return NULL;
}
int main(){
    resources_init();
    
    resources_create(A, 3);
    resources_create(B, 3);
    resources_create(C, 3);
    resources_create(D, 3);
    
    endtime = time_nanos() + 50e6;
    
    pthread_t t[24];
    for(intptr_t i = 1; i < 24; ++i)
        pthread_create(t+i, NULL, func, (void*)i);
    
    func(0);
    
    for(intptr_t i = 1; i < 24; ++i)
        pthread_join(t[i], NULL);
    
    puts("ok");
    return 0;
}
