#include "common.h"

// threads that wait for resources forever block some of them, but other
// threads should be started for there is enough free items

enum Kind { Z, A, B, C, D, E };

void* t1(void *_){
    wait_state(1);
    adv_state(2);
    rv = resources_take(4, (struct resources_request[]){{A,10},{C,4},{D,8},{E,4}});
    
    assert(0);
    // here we hang forever
    
    return _;
}

void* t2(void *_){
    wait_state(2);
    // t1 hangs, so wait a while
    nanosleep(&(struct timespec){0,5e6}, NULL);
    
    rv = resources_take(1, (struct resources_request[]){{C,4}});
    assert(!rv);
    
    adv_state(3);
    
    nanosleep(&(struct timespec){0,5e6}, NULL);
    
    assert(state==3);
    
    rv = resources_return(C,4);
    assert(!rv);
    
    wait_state(5);
    
    rv = resources_take(2, (struct resources_request[]){{C,4}, {E,4}});
    assert(!rv);
    
    wait_state(6);
    nanosleep(&(struct timespec){0,5e6}, NULL);
    
    rv = resources_return(E,2);
    assert(!rv);
    
    wait_state(7);
    
    rv = resources_return(E,2);
    assert(!rv);
    rv = resources_return(C,4);
    assert(!rv);
    
    return _;
}

void* t3(void *_){
    wait_state(3);
    rv = resources_take(1, (struct resources_request[]){{C,4}});
    assert(!rv);
    
    adv_state(4);
    
    rv = resources_return(C,4);
    assert(!rv);
    
    adv_state(5);
    
    nanosleep(&(struct timespec){0,5e6}, NULL);
    adv_state(6);
    rv = resources_take(2, (struct resources_request[]){{C,2}, {E,4}});
    assert(!rv);
    
    adv_state(7);
    
    rv = resources_return(E,4);
    assert(!rv);
    rv = resources_return(C,2);
    assert(!rv);
    
    return _;
}

void* t4(void *_){
    wait_state(5);
    rv = resources_take(1, (struct resources_request[]){{D,4}});
    assert(0);
    
    // here we hang forever
    
    return _;
}

void sigusr1(int _){ pthread_exit(NULL); }
void terminator(int _){ puts("ok"); exit(0); };

int main(){
    resources_init();
    
    resources_create(A, 10);
    resources_create(B, 10);
    resources_create(C, 10);
    resources_create(D, 10);
    resources_create(E, 10);
    
    THREADS_SPAWN(t1, t2, t3, t4);
    
    rv = resources_take(2, (struct resources_request[]){{A,10},{B,4}});
    assert(!rv);
    
    adv_state(1);
    
    pthread_join(threadIds[1], NULL);
    pthread_join(threadIds[2], NULL);
    
    signal(SIGUSR1, sigusr1);

    // pthread_exit is not async-signal-safe and it sometimes shows off here...
    signal(SIGALRM, terminator);
    alarm(1);
    
    pthread_kill(threadIds[0], SIGUSR1);
    pthread_join(threadIds[0], NULL);
    
    pthread_kill(threadIds[3], SIGUSR1);
    pthread_join(threadIds[3], NULL);
    
    
    puts("ok");
    return 0;
}
