#include "common.h"

// attempting to take lots of resource kinds at the same time

#define MAX 12

int pow2(int i){
    if(i==0) return 1;
    return 2*pow2(i-1);
}

int main(){
    
    resources_init();
    
    struct resources_request *rr = malloc(sizeof(*rr)*pow2(MAX));
    
    rv = resources_create(0, 1);
    assert(!rv);    
    
    for(int i = 1 ; i <= MAX ; ++i){
        for(int j = pow2(i-1); j < pow2(i); ++j){
            rv = resources_create(j, 1);
            assert(!rv);
        }
        
        for(int j = 0; j < pow2(i); ++j)
            rr[j] = (struct resources_request){j,1};
        
        rv = resources_take(pow2(i), rr);
        assert(!rv);
        
        for(int j = 0; j < pow2(i); ++j){
            resources_return(j, 1);
            assert(!rv);
        }
    }
    
    free(rr);
    puts("ok");
    return 0;
}
