#include "common.h"

// checking if fifo order is preserved on the same resource

pthread_mutex_t startMtx=PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  startCnd=PTHREAD_COND_INITIALIZER;

#define MAX 128

void* func(void *arg){
    intptr_t i = (intptr_t) arg;    
    if(i==MAX/2) pthread_cond_signal(&startCnd);
    
    nanosleep(&(struct timespec){0,8e6}, NULL);
    
    pthread_t t;
    if(i<=MAX)
        pthread_create(&t, NULL, func, (void*)(i+1));
    int rv = resources_take(1, (struct resources_request[1]){{1,1}});
    assert(!rv);
    
    adv_state(i);
    
    nanosleep(&(struct timespec){0,4e6}, NULL);
    
    rv = resources_return(1, 1);
    assert(!rv);
    
    if(i<=MAX)
        pthread_join(t, NULL);
    
    return NULL;
}
int main(){
    resources_init();
    
    resources_create(1, 1);

    rv = resources_take(1, (struct resources_request[1]){{1,1}});
    assert(!rv);
    
    pthread_t t;
    pthread_create(&t, NULL, func, (void*)1);
    
    pthread_mutex_lock(&startMtx);    
    pthread_cond_wait(&startCnd, &startMtx);
    pthread_mutex_unlock(&startMtx);
    
    rv = resources_return(1, 1);
    assert(!rv);
    
    pthread_join(t, NULL);
    
    puts("ok");
    return 0;
}
