#include "common.h"

// checking if order is preserved when thr#1 wants ab, #2 bc, #3 cd, #4 de, … 

pthread_mutex_t startMtx=PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  startCnd=PTHREAD_COND_INITIALIZER;

#define MAX 256

void* func(void *arg){
    intptr_t i = (intptr_t) arg;    
    if(i==MAX/2) pthread_cond_signal(&startCnd);
    
    nanosleep(&(struct timespec){0,8e6}, NULL);
    
    pthread_t t;
    if(i<=MAX)
        pthread_create(&t, NULL, func, (void*)(i+1));
    int rv = resources_take(2, (struct resources_request[2]){{i,1},{i+1,1}});
    assert(!rv);
    
    adv_state(i);
    
    nanosleep(&(struct timespec){0,4e6}, NULL);
    
    rv = resources_return(i, 1);
    assert(!rv);
    rv = resources_return(i+1, 1);
    assert(!rv);
    
    if(i<=MAX)
        pthread_join(t, NULL);
    
    return NULL;
}
int main(){
    resources_init();
    
    for(int i = 0; i <= MAX+2; ++i)
        resources_create(i, 1);

    rv = resources_take(2, (struct resources_request[2]){{1,1},{2,1}});
    assert(!rv);
    
    pthread_t t;
    pthread_create(&t, NULL, func, (void*)1);
    
    pthread_mutex_lock(&startMtx);    
    pthread_cond_wait(&startCnd, &startMtx);
    pthread_mutex_unlock(&startMtx);
    
    rv = resources_return(1, 1);
    rv = resources_return(2, 1);
    assert(!rv);
    
    pthread_join(t, NULL);
    
    puts("ok");
    return 0;
}
