#pragma once
#include <stdatomic.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include <pthread.h>
#include <assert.h>
#include <errno.h>
#include <threads.h>
#include <time.h>
#include <signal.h>

// writing debug message to file descriptor 3 for the purpose of checking with check.sh
// to see the messages while running the programs in bash, add the redirection '3>&1'
#define assertVerbose(COND, STR, ...) if(!(COND)){ dprintf(3, STR "\n" __VA_OPT__(,) __VA_ARGS__); assert((COND)); }

/**
 * NEVER PUT VARIABLES IN A HEADER FILE UNLESS YOU REALLY KNOW WHAT YOU ARE DOING
 * (or sooner or later you'll have to deal with 'xyz defined multiple times' error)
 */

pthread_mutex_t m = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cv = PTHREAD_COND_INITIALIZER;
int state = 0;
void adv_state(int i){
    pthread_mutex_lock(&m);
    assertVerbose(state==i-1, "adv_state %d→%d", state, i);
    state=i;
    pthread_cond_broadcast(&cv);
    pthread_mutex_unlock(&m);
}
//
void wait_state(int i){
    pthread_mutex_lock(&m);
    while(state<i)
        pthread_cond_wait(&cv, &m);
    pthread_mutex_unlock(&m);
}
//
void adv_state_nocheck(){
    pthread_mutex_lock(&m);
    state++;
    pthread_cond_broadcast(&cv);
    pthread_mutex_unlock(&m);
}


thread_local int rv;

uint64_t endtime;
//
uint64_t time_nanos(){
    struct timespec t;
    clock_gettime(CLOCK_MONOTONIC, &t);
    return t.tv_sec*1e9+t.tv_nsec;
}
//
#define LOOP(X)                 \
while(endtime>time_nanos()){    \
    for(int _i=0;_i<128;++_i){  \
        X                       \
    }                           \
}

#define THREADS_SPAWN(...)                                                    \
void* (*threadRoutines[])(void *)={__VA_ARGS__};                              \
int threadCount = sizeof(threadRoutines)/sizeof(*threadRoutines);             \
pthread_t threadIds[threadCount];                                             \
for(int i = 0 ; i < threadCount; ++i)                                         \
    pthread_create(threadIds+i, NULL, threadRoutines[i], NULL);
//
#define THREADS_JOIN                                                          \
for(int i = 0 ; i < threadCount; ++i)                                         \
    pthread_join(threadIds[i], NULL);

#include "resources.h"
